#include <LiquidCrystal.h>
#include <LedControl.h>
LiquidCrystal lcd(0, 1, 2, 3, 4, 5, 6);
int wert = 0, sensorfehler = 0, f = 0, x = 0,y = 0, DIN = 12, CS = 11, CLK = 10, d = 0, s1 = 0, s2 = 0, m1 = 0, m2 = 0;
int minute = 0, sekunde = 0, zehntelsekunde_neu, zehntelsekunde_alt, minutealt = 0, sekundealt = 0, zehntelsekundealt = 0; // Uhr initialisieren
int minutemax = 99, sekundemax = 99, zehntelsekundemax = 99;
long startzeit = 0, laufzeit = 0, laufzeit_max = 0; //Variablen für die Zeitmessung
long bestzeit[4];
boolean taster = LOW;
boolean laserstatus = false;
boolean timerstatus = false;
unsigned long currentMillis;
unsigned long previousMillis; // Timer zum berechnen der Auslösesperre
unsigned long startMillis; // Timer zum brechnen der stoppzeit
int buttonState = LOW;             // aktueller Status vom Taster 
int lastButtonState = LOW;   // letzter Status vom taster
long lastDebounceTime = 0;  
long debounceDelay = 50;    
byte eins[8] =   {0x00, 0x00, 0x00, 0xFF, 0xFF, 0x60, 0x20, 0x00}; // alle benötigten Zeichen werden hier definiert
byte zwei[8] =   {0x00, 0x00, 0x63, 0xF3, 0xDB, 0xCF, 0x67, 0x00};
byte drei[8] =   {0x00, 0x00, 0x76, 0xFF, 0xDB, 0xDB, 0xC3, 0x00};
byte vier[8] =   {0x00, 0x00, 0xFF, 0xFF, 0x18, 0xF0, 0xF0, 0x00};
byte fuenf[8] =   {0x00, 0x00, 0xCE, 0xDF, 0xDB, 0xFB, 0xF3, 0x00};
byte sechs[8] =   {0x00, 0x00, 0xCE, 0xDF, 0xDB, 0x7B, 0x3E, 0x00};
byte sieben[8] =   {0x00, 0x00, 0x7F, 0xFF, 0xC0, 0xC0, 0xC0, 0x00};
byte acht[8] =   {0x00, 0x00, 0x6E, 0xDB, 0xDB, 0xDB, 0x6E, 0x00};
byte neun[8] =   {0x00, 0x00, 0x7E, 0xFF, 0xD3, 0xF3, 0x62, 0x00};
byte nul[8] =   {0x00, 0x00, 0x7E, 0xFF, 0xC3, 0xFF, 0x7E, 0x00};
byte r[8] =   {0x00,0x00,0x63,0xF7,0xDC,0xD8,0xFF,0xFF};
byte cc[8] =   {0x00,0x18,0xDB,0xDB,0xC3,0xC3,0x7E,0x3C};
byte c[8] =   {0x00,0x00,0xC3,0xC3,0xC3,0xC3,0x7E,0x3C};
byte a[8] =   {0x00,0x00,0x3F,0x7F,0xCC,0xCC,0x7F,0x3F};
byte e[8] =   {0x00,0x00,0xC3,0xDB,0xDB,0xDB,0xFF,0xFF};
byte t[8] =   {0x00,0x00,0xC0,0xC0,0xFF,0xFF,0xC0,0xC0};
byte i[8] =   {0x00,0x00,0x00,0x00,0xDF,0xDF,0x00,0x00};
byte m[8] =   {0x00,0x00,0xFF,0x7F,0x30,0x30,0x7F,0xFF};
byte o[8] =   {0x00,0x00,0x7E,0xFF,0xC3,0xC3,0xFF,0x7E};


byte einsd[8] =   {0x24, 0x00, 0xFF, 0xFF, 0x60, 0x20, 0x00, 0x00}; // hier sind zahlen inclusive Doppelpunkt
byte zweid[8] =   {0x24, 0x00, 0x63, 0xF3, 0xDB, 0xCF, 0x67, 0x00};
byte dreid[8] =   {0x24, 0x00, 0x76, 0xFF, 0xDB, 0xDB, 0xC3, 0x00};
byte vierd[8] =   {0x24, 0x00, 0xFF, 0xFF, 0x18, 0xF0, 0xF0, 0x00};
byte fuenfd[8] =   {0x24, 0x00, 0xCE, 0xDF, 0xDB, 0xFB, 0xF3, 0x00};
byte sechsd[8] =   {0x24, 0x00, 0xCE, 0xDF, 0xDB, 0x7B, 0x3E, 0x00};
byte siebend[8] =   {0x24, 0x00, 0x7F, 0xFF, 0xC0, 0xC0, 0xC0, 0x00};
byte achtd[8] =   {0x24, 0x00, 0x6E, 0xFF, 0xDB, 0xFF, 0x6E, 0x00};
byte neund[8] =   {0x24, 0x00, 0x7E, 0xFF, 0xD3, 0xF3, 0x62, 0x00};
byte nuld[8] =   {0x24, 0x00, 0x7E, 0xFF, 0xC3, 0xFF, 0x7E, 0x00};
byte xxx[8] =   {0xC3, 0xE7, 0x3C, 0x18, 0x3C, 0xE7, 0xC3, 0x00};
LedControl lc = LedControl(DIN, CLK, CS, 5);  // Matrix 5 Stück
void setup()
{
  int i = 0;
  for (i = 0; i < 5; i++)
  {
    lc.shutdown(i, false);      //The MAX72XX is in power-saving mode on startup
    lc.setIntensity(i, 8);     // Set the brightness to maximum value
    lc.clearDisplay(i);         // and clear the display
  }
  bestzeit[0] = 9999999;
  bestzeit[1] = 9999999;
  bestzeit[2] = 9999999;
  bestzeit[3] = 9999999;
  bestzeit[4] = 9999999;
  pinMode(7, INPUT); //taster zum Fahrer wählen
  pinMode(A0, INPUT); // port lichtschranke
  pinMode(8, OUTPUT); // port LED
  lcd.begin(20, 4);
  lcd.setCursor(1, 0);
  lcd.print("F1");
  lcd.setCursor(1, 1);
  lcd.print("F2");
  lcd.setCursor(1, 2);
  lcd.print("F3");
  lcd.setCursor(1, 3);
  lcd.print("F4");
  //previousMillis = currentMillis;
}
void loop()
{
  if (y<1){ text();}
  y=2;
  taster = digitalRead(7);
  if (taster != lastButtonState) {
    // reset the debouncing timer
    lastDebounceTime = millis();
  }
  if ((millis() - lastDebounceTime) > debounceDelay) {
    // if the button state has changed:
    if (taster != buttonState  && laserstatus == false) {
      buttonState = taster;
      laufzeit = 0;
      if (buttonState == HIGH) {
        x = f ; // Wert altes f in x speichern um den alten Pfeil löschen zu können
        f++;
        if (f > 3) {
          f = 0;
        }
      }
    }
  }
  lastButtonState = taster;
  lcd.setCursor (0, x); lcd.print(" ");
  lcd.setCursor (0, f); lcd.print(">");
  lcd.setCursor (4, f);
  currentMillis = millis();
  wert = analogRead(A0); // Sensor auslesen
  if (wert > 500 && currentMillis - previousMillis > 2000 ) // sperre das laser innerhalb von 2 sek. nicht erneut auslöst
  {
    previousMillis = currentMillis ;
    startzeit = millis();
    laserstatus = !laserstatus;
    if (laserstatus == false) {
      x = f;
      f++;
      if (f > 3) {
        f = 0;
      }
    }
  }
  if (laserstatus == true )
  {
    analogWrite(8, 255); // led an
    laufzeit = millis() - startzeit;
    zehntelsekunde_neu = (laufzeit / 100) % 10; // Das %-Zeichen ist der Modulo-Operator
    // Zeit nur ausgeben, wenn Zehntelsekunde sich verändert hat
    if (zehntelsekunde_neu != zehntelsekunde_alt)
    {
      if (zehntelsekunde_neu == 0)
      {
        sekunde++;
        if (laufzeit < 50)
        {
          sekunde = 0;
        }
        if (sekunde == 60)
        {
          sekunde = 0;
          minute++;
          if (minute == 60)
          {
            minute = 0;
          }
        }
      }
      if (minute < 10) lcd.print("0"); //damit die Zahl immer zweistellig angezeigt wird
      lcd.print(minute);
      lcd.print(":");
      if (sekunde < 10) lcd.print("0"); //damit die Zahl immer zweistellig angezeigt wird
      lcd.print(sekunde);
      lcd.print(".");
      lcd.print(zehntelsekunde_neu);
      s1 = sekunde % 10; // sekunde berechnen
      s2 = sekunde / 10; // Sekunde zehner berechnen
      m1 = minute % 10; // Minute berechnen
      m2 = minute / 10; // Minute zehner berechnen

// Ausgabe der Zahlen auf der DOT Matrix
      switch (m2) { // Zehner schreiben
        case 1:
          printByte(eins, 5);
          break;
        case 2:
          printByte(zwei, 5);
          break;
        case 3:
          printByte(drei, 5);
          break;
        case 4:
          printByte(vier, 5);
          break;
        case 5:
          printByte(fuenf, 5);
          break;
        case 6:
          printByte(sechs, 5);
          break;
        case 7:
          printByte(sieben, 5);
          break;
        case 8:
          printByte(acht, 5);
          break;
        case 9:
          printByte(neun, 5);
          break;
        default:
          printByte(nul, 5);
          break;
      }

      switch (m1) { // Zehner schreiben
        case 1:
          printByte(einsd, 4);
          break;
        case 2:
          printByte(zweid, 4);
          break;
        case 3:
          printByte(dreid, 4);
          break;
        case 4:
          printByte(vierd, 4);
          break;
        case 5:
          printByte(fuenfd, 4);
          break;
        case 6:
          printByte(sechsd, 4);
          break;
        case 7:
          printByte(siebend, 4);
          break;
        case 8:
          printByte(achtd, 4);
          break;
        case 9:
          printByte(neund, 4);
          break;
        default:
          printByte(nuld, 4);
          break;
      }



      switch (s2) { // Zehner schreiben
        case 1:
          printByte(eins, 3);
          break;
        case 2:
          printByte(zwei, 3);
          break;
        case 3:
          printByte(drei, 3);
          break;
        case 4:
          printByte(vier, 3);
          break;
        case 5:
          printByte(fuenf, 3);
          break;
        case 6:
          printByte(sechs, 3);
          break;
        case 7:
          printByte(sieben, 3);
          break;
        case 8:
          printByte(acht, 3);
          break;
        case 9:
          printByte(neun, 3);
          break;
        default:
          printByte(nul, 3);
          break;
      }



      switch (s1) { // Sekunde schreiben
        case 1:
          printByte(einsd, 2);
          break;
        case 2:
          printByte(zweid, 2);
          break;
        case 3:
          printByte(dreid, 2);
          break;
        case 4:
          printByte(vierd, 2);
          break;
        case 5:
          printByte(fuenfd, 2);
          break;
        case 6:
          printByte(sechsd, 2);
          break;
        case 7:
          printByte(siebend, 2);
          break;
        case 8:
          printByte(achtd, 2);
          break;
        case 9:
          printByte(neund, 2);
          break;
        default:
          printByte(nuld, 2);
          break;
      }


      switch (zehntelsekunde_neu) { //zehntel auf die Matrix schreiben
        case 1:
          printByte(eins, 1);
          break;
        case 2:
          printByte(zwei, 1);
          break;
        case 3:
          printByte(drei, 1);
          break;
        case 4:
          printByte(vier, 1);
          break;
        case 5:
          printByte(fuenf, 1);
          break;
        case 6:
          printByte(sechs, 1);
          break;
        case 7:
          printByte(sieben, 1);
          break;
        case 8:
          printByte(acht, 1);
          break;
        case 9:
          printByte(neun, 1);
          break;
        default:
          printByte(nul, 1);
          break;
      }

      zehntelsekunde_alt = zehntelsekunde_neu;
      minutealt = minute;
      sekundealt = sekunde;
    }
  }

  else
  {
    digitalWrite (8, LOW); // LED aus
    // Bestzeit schreiben --------------
    if (laufzeit < bestzeit[x] & laufzeit > 2020 ) {
      lcd.setCursor(13, x);
      minutemax = minute;
      sekundemax = sekunde;
      zehntelsekundemax = zehntelsekunde_neu;
      bestzeit[x] = laufzeit;
      if (minutemax < 10) lcd.print("0"); //damit die Zahl immer zweistellig angezeigt wird
      lcd.print(minutemax);
      lcd.print(":");
      if (sekundemax < 10) lcd.print("0"); //damit die Zahl immer zweistellig angezeigt wird
      lcd.print(sekundemax);
      lcd.print(".");
      lcd.print(zehntelsekundemax);
      flash(10);
      minute = 0;
      sekunde = 0;
      zehntelsekunde_neu = 0;
    }
    // Bestzeit nicht überschreiben und Zeitmessung auf null zurück weil Fehler auftrat
    if (laufzeit < 2005 & laufzeit > 0 ) {
      minute = 0;
      sekunde = 0;
      zehntelsekunde_neu = 0;
      if (minute < 10) lcd.print("0"); //damit die Zahl immer zweistellig angezeigt wird
      lcd.print(minute);
      lcd.print(":");
      if (sekunde < 10) lcd.print("0"); //damit die Zahl immer zweistellig angezeigt wird
      lcd.print(sekunde);
      lcd.print(".");
      lcd.print(zehntelsekunde_neu);

      flash1(5); // Springt zu Fehler XXXXX im DOT anzeigen solange Taste 1 nicht gedrückt
    }
    // zeitnahme löschen ---------------

  }   //------------Modus Uhr-------------Ende
}
void flash(int y)
{
  int j = 0;
  for (j = 0; j < y; j++)
  {
    int i = 0;
    for (i = 0; i < 5; i++)
    {
      lc.setIntensity(i, 12);     // Set the brightness to maximum value
    }
    delay(100);
    i = 0;
    for (i = 0; i < 5; i++)
    {
      lc.setIntensity(i, 1);     // Set the brightness to low value
    }
    delay(100);
    i = 0;
    for (i = 0; i < 5; i++)
    {
      lc.setIntensity(i, 8);     // Set the brightness to medium value
    }
  }
}
// error wenn laser offline
void flash1(int y)
{

  while (digitalRead(7) == LOW  ) {
    int i = 0;
    
    printByte(e, 5);
    printByte(r, 4);
     printByte(r, 3);
      printByte(o, 2);
       printByte(r, 1);
    for (i = 0; i < 6; i++)
    {
      lc.setIntensity(i, 12);     // Set the brightness to maximum value
     }
    delay(100);
    i = 0;
    for (i = 0; i < 6; i++)
    {
      lc.setIntensity(i, 1);     // Set the brightness to lowest value
        }
    delay(100);
    i = 0;
    for (i = 0; i < 6; i++)
    {
      lc.setIntensity(i, 8);     // Set the brightness to normal value
      }
  }
  laserstatus = false;
  laufzeit = 0;
}
//text am Anfang RC-CAR RACE TIMER
float text()
{
   float y=2;
   printByte(r, 5);
    printByte(cc, 4);
     printByte(c, 3);
      printByte(a, 2);
       printByte(r, 1);
       delay(2000); 
    printByte(r, 5);
    printByte(a, 4);
     printByte(c, 3);
      printByte(e, 2);
         lc.clearDisplay(0); 
       delay(2000); 
    printByte(t, 5);
    printByte(i, 4);
     printByte(m, 3);
      printByte(e, 2);
       printByte(r, 1);
       delay(2000);  
    return y;   
  }
void printByte(byte character [], int m)
{
  m --; // M ist die Nummer der Matrix welche angesteuert wird
  int i = 0;
  for (i = 0; i < 8; i++)
  {
    lc.setRow(m, i, character[i]);
  }
}

